/* 16Ʈ ȯ 32Ʈ ȯ int ϴ α׷(PortIntBad.c) */
#include <stdio.h>
#include <string.h>
#include <limits.h>
#define MAX_SIZE 8

/* 16Ʈ ȯ Ѵ*/
/* #define OS_16_BIT */ /*  ߿ ϳ Ѵ*/
/* 32Ʈ ȯ Ѵ*/
#define OS_32_BIT /*  ߿ ϳ Ѵ*/

#ifdef OS_16_BIT 
/* 16Ʈ ȯ nint͡nuint typedef */
typedef long nint;
typedef unsigned long nuint;
#elif defined(OS_32_BIT)
/* 32Ʈ ȯ nint͡nuint typedef */
typedef int nint;
typedef unsigned int nuint;
#endif /* OS_16_BIT */

char strwork1[MAX_SIZE + 1] = "";
char strwork2[MAX_SIZE + 3] = "";

/* unsigned long κ 16 ڿ ϴ Լ*/
char *genhexchars(unsigned long num, int bytes)
{
    int i = 0, j, length, halfbytecount = 0;
    unsigned char ch;
    /* 16  迭*/
    static unsigned char hexchars[] = { '0', '1', '2', '3',
    '4', '5', '6', '7', '8', '9', 'A', 'B', 'C',
    'D', 'E', 'F' };
    
    /* strwork2 պκп ڿ  Ѵ*/
    strcpy(strwork2, "0x");
    /* ڸ 16 ڿ ȯѴ*/
    while (i < MAX_SIZE) { 
        /* 16  Ѵ*/
        ch = (unsigned char) num % 16;
        /*  Ʈ 16 ǥѴ*/
        strwork1[i++] = hexchars[ch & 0x0f];
        /* 4Ʈ  Ʈ Ѵ*/
        num >>= 4; 
        /* ڷ  Ʈ ó  Ѵ*/
        if (++halfbytecount / 2 == bytes)
            break;
    }
    /*   ڸ Ѵ*/
    strwork1[i] = '\0';
    /* ڿ ̸ Ѵ*/
    length = strlen(strwork1);
    /* ڿ  ġѴ*/
    for (i = 0, j = length - 1; i < j; i++, j--) { 
        ch = strwork1[i];
        strwork1[i] = strwork1[j];
        strwork1[j] = ch;
    }
    /*  strwork2 Ѵ*/
    strcat(strwork2, strwork1);
    return strwork2;
}

int main(void)
{
#ifdef OS_16_BIT 
    /* nint Ѵ*/
    nint ni = LONG_MAX;
    /* nuint Ѵ*/
    nuint nui = ULONG_MAX;
#elif defined(OS_32_BIT)
    /* nint Ѵ*/
    nint ni = INT_MAX;
    /* nuint Ѵ*/
    nuint nui = UINT_MAX;
#endif /* OS_16_BIT */
#ifdef OS_16_BIT
    printf("LONG_MAX  %d 16  ǥ%s\n", 
            LONG_MAX, genhexchars(LONG_MAX, 4));
    printf("LONG_MIN  %d 16  ǥ%s\n",
            LONG_MIN, genhexchars(LONG_MIN, 4));
    printf("ULONG_MAX  %u 16  ǥ%s\n",
            ULONG_MAX, genhexchars(ULONG_MAX, 4));
    /* nint  Ѵ*/ 
    printf("OS_16_BIT ȯ ni:%d\n", ni);
    /* nuint  Ѵ*/
    printf("OS_16_BIT ȯ nui:%u\n", nui);
#elif defined(OS_32_BIT)
    printf("INT_MAX  %d 16  ǥ%s\n", 
            INT_MAX, genhexchars(INT_MAX, 4));
    printf("INT_MIN  %d 16  ǥ%s\n",
            INT_MIN, genhexchars(INT_MIN, 4));
    printf("UINT_MAX  %u 16  ǥ%s\n",
            UINT_MAX, genhexchars(UINT_MAX, 4));
    /* nint  Ѵ*/ 
    printf("OS_32_BIT ȯ ni:%d\n", ni);
    /* nuint  Ѵ*/
    printf("OS_32_BIT ȯ nui:%u\n", nui);
#endif /* OS_16_BIT */

    return 0;
}
