/*  ڵ带  ϴ α׷(VariableRecordsBad.c) */
/* ֣( ) VariableRecordsBad  ϸ*/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#define MAX_STR 128
#define RECORD_ITEMS 5
#define BUFFER_SIZE 1024
/*   ͸  ϴ STOCK ü */
typedef struct stock {
	int stocknumber;
	char stockname[MAX_STR + 1];
	char description[MAX_STR + 1];
	int volume;
	int cost;
} STOCK;

/*  ޽  ϴ Լ*/
void errorexit(char *pstr, int flag)
{
    fprintf(stderr, pstr);
    if (flag)
        exit(EXIT_FAILURE);
    else
        exit(EXIT_SUCCESS);
}

/* Ϸ  ڵ带 ᳻ Լ*/
void writerecord(STOCK records[], int items, unsigned int size,
FILE *pfile)
{
	int i; /*   */

	/* ڵ */
	if (fwrite(&items, sizeof(int), 1, pfile) ! = 1)
	goto error; /* ߴ*/ 
	/* items ü  Ͽ */
	for (i = 0; i < items; i++) {
		/* ڵ ͸ */
		if (fwrite(&records[i], sizeof(char), size, pfile)
			! = size) 
		goto error; /* ߴ*/ 
	}
	return;
error:
	/*  ݴ´*/
	fclose(pfile);
	errorexit(" ⿡ ߽ϴ. \n", EXIT_FAILURE);
}

/*  ڵ带 а ϴ Լ*/
void showrecord(int recorditem, unsigned int size, FILE *pfile)
{
	/*   */
	int i, items;
	STOCK work = { 0 };
	/* ġ ε(indicator) ǰ Ѵ*/
	rewind(pfile);
	/* ڵ(items) о*/
	if (fread(&items, sizeof(unsigned int), 1, pfile) ! = 1)
		goto error; /* ߴ*/ 
	/* μ  Ѵ*/
	if (recorditem >= items) {
		/*  ݴ´*/
		fclose(pfile);
		errorexit(" ڵ ߰ߵ ʾҽϴ. \n",
				  EXIT_FAILURE);
	}
	
	/*  ڵ ġ ε(indicator) ̵Ѵ*/
	for (i = 0; i < recorditem; i++)
		/* ġ ε(indicator) ̵Ѵ*/
		fseek(pfile, size, SEEK_CUR); 
		
	/* Ÿ ڵ带 о*/
	if (fread(&work, sizeof(char), size, pfile) ! = size) 
		goto error; /* ߴ*/ 
		
	printf("\n %dڵ 룺 %d\n", recorditem + 1, size);
	printf("ǰ ȣ%d\n", (unsigned int) work.stocknumber);
	printf("ǰ%s\n", work.stockname);
	printf("ǰ  %s\n", work.description);
	printf("%d\n", (int) work.volume);
	printf(" ܰ%d\n", (int) work.cost);
	printf("  ݣ%d\n", (int) work.cost * (int) work.volume);
	return;
error:
	/*  ݴ´*/
	fclose(pfile);
	errorexit(" б⿡ ߽ϴ. \n", EXIT_FAILURE);
}

int main(int argc, char *argv[])
{
/* FILE * Ʈ */
FILE *pfile = NULL;
/* ϸ (argv) */
char *pfilename = "";
/*   */
int i;
/* STOCK ü 迭 , ʱȭѴ*/
STOCK stockarray[RECORD_ITEMS] = { 0 };
/* ü */
unsigned int size = sizeof stockarray / RECORD_ITEMS;
/* α׷ ⵿ μ   ǥѴ*/
if (argc ! = 2 || ! strcmp(argv[1], "/? ")
|| ! strcmp(argv[1], "-? ")) {
errorexit("α׷ \n"
"⵿ VariableRecordsBad  ϸ \n",
EXIT_SUCCESS);
}
pfilename = argv[1]; /* μ  ϸ ´*/
/*  ̳ʸ    */
if ((pfile = fopen(pfilename, "wb+")) == NULL)
errorexit("  ʾҽϴ. \n", EXIT_FAILURE);
/* ǰ ڵ带  Ѵ*/
stockarray[0]. stocknumber = 31459;
stockarray[0]. volume = 5000;
stockarray[0]. cost = 1800;
strcpy(stockarray[0]. stockname, "׸ ()");
strcpy(stockarray[0]. description, " ڿ ϴ");
stockarray[1]. stocknumber = 55203;
stockarray[1]. volume = 6000;
stockarray[1]. cost = 4500;
strcpy(stockarray[1]. stockname, " A");
strcpy(stockarray[1]. description, "   ");
stockarray[2]. stocknumber = 20256;
stockarray[2]. volume = 4500;
stockarray[2]. cost = 2400;
strcpy(stockarray[2]. stockname, "׸ ()");
strcpy(stockarray[2]. description,
"̴ ణ °̹Ƿ Ŭӿ ");

/* 迭 stockarray ͸ ǥѴ*/
for (i = 0; i < RECORD_ITEMS; i++) {
printf("%dڵ壺%d ", i + 1,
stockarray[i]. stocknumber);
printf("%s ", stockarray[i]. stockname);
printf("%s ", stockarray[i]. description);
printf("%d ", stockarray[i]. volume);
printf("%d\n", stockarray[i]. cost);
}
/* 迭 stockarray ڵ带 Ͽ */
writerecord(stockarray, RECORD_ITEMS, size, pfile);
/*   ڵ带  б ǥѴ*/
showrecord(2, size, pfile);
showrecord(1, size, pfile);
showrecord(4, size, pfile);
showrecord(0, size, pfile);
showrecord(3, size, pfile);
/*  ݴ´*/
fclose(pfile);
return 0;
}
