/*  ޸ Ҵ 
 迭 ϴ α׷(DynamicArrayGood.c) */
#include <stdio.h>
#include <stdlib.h>
#include <limits.h>
#define ALLOC_UNIT 20

/* 迭 Ҹ Ű */
int *pmem = NULL;
/*   迭 Ű */
int **pnarray = NULL, **ptemp = NULL;
/*   迭  ũ⸦ ϴ */
int capacity = 0;
int item_count = 0, temp; /* 迭  Ҽ ϴ  */
int b_first = 1; /*  Ҵ  ÷*/

/*   迭  ϴ Լ*/
int size(int n) /* ο ũ⸦ Ѵ*/
{
    if (b_first) { /*  ȣ Ѵ*/
        /*  nũ ޸𸮸 ҴѴ*/
        pnarray = (int **) calloc(n, sizeof(int *));
        if (pnarray == NULL) {
            fprintf(stderr, "޸ Ҵ翡 ߽ϴ. \n");
            exit(EXIT_FAILURE);
        }
        capacity = n; /*  뷮 Ѵ*/
        b_first = 0;
        return n;
    }
    else { /*  ȣ ƴ */
        /* Ұ  */
        if (n < item_count - 1)
            return INT_MAX; /* */
        /* ޸  ũ⸦ Ѵ*/
        ptemp = (int **) realloc(pnarray,
        n * sizeof(int *));
        if (ptemp ! = NULL) {
            /* pnarray ͸ ο ptemp ٲ۴*/
            pnarray = ptemp; /* pnarray ͸ Ѵ*/
            capacity = n; /*  뷮 Ѵ*/
            return n;
        }
        else {
            fprintf(stderr, "޸ Ҵ翡 ߽ϴ. \n");
            exit(EXIT_FAILURE);
        }
    }
}

/* 迭  Ҹ ߰ϴ Լ*/
int additem(int val)
{
    /*  ALLOC_UNIT ũ⸦ ȮѴ*/
    if (capacity == 0) size(ALLOC_UNIT);
    /*  뷮 ϸ ߰Ѵ*/
    else if (item_count >= capacity) size(capacity + ALLOC_UNIT);
    /* 迭 ҿ ޸𸮸 ҴѴ*/
    pmem = (int *) calloc(1, sizeof(int));
    if (pmem == NULL) {
        fprintf(stderr, "޸ Ҵ翡 ߽ϴ. \n");
        exit(EXIT_FAILURE);
    }
    /*   Ѵ*/
    *pmem = val;
    /* ͸ Ѵ*/
    pnarray[item_count++] = pmem;
    return val;
}

/* 迭 Ҹ  Լ*/
int getat(int index)
{
    if (index >= item_count || index < 0)
        return INT_MAX; /* */
    return *pnarray[index];
}

/* 迭 Ҹ ϴ Լ*/
int setat(int index, int val)
{
    if (index >= item_count || index < 0)
        return INT_MAX; /* */
    /*  ҿ ޸𸮸 ҴѴ*/
    pmem = (int *) calloc(1, sizeof(int));
    if (pmem == NULL) {
        fprintf(stderr, "޸ Ҵ翡 ߽ϴ\nb");
        exit(EXIT_FAILURE);
    }
    /*   Ѵ*/
    *pmem = val;
    /* ޸   Ѵ*/
    free(pnarray[index]); 
    /* ͸ Ѵ*/
    pnarray[index] = pmem;
    return val;
}

/*  迭 ϴ Լ*/
void delete(void)
{
    int i; /*   */
    /* 迭  Ҹ Ѵ*/
    for (i = 0; i < item_count; i++) {
        /*   ޸𸮸 ϰ Ϳ NULL Ѵ */
        free(pnarray[i]); pnarray[i] = NULL;
    }
    /* 迭 ü Ѵ*/
    free(pnarray); pnarray = NULL;
    /*  ͸  Ѵ*/
    capacity = item_count = 0; b_first = 1;
}

int main(void)
{
    int i; /*   */
    
    /*  迭 Ҹ ߰Ѵ*/
    for (i = 0; i < ALLOC_UNIT * 5; i++) additem(i);
    
    /*  迭 Ҹ Ѵ*/
    for (i = 0; i < ALLOC_UNIT * 5; i++)
        printf("%d ", getat(i)); /* ϸ INT_MAXȯ */
    printf("\n");
    
    delete(); /*  迭 Ѵ*/
    
    /*  迭 Ҹ ߰Ѵ*/
    for (i = 0; i < ALLOC_UNIT * 5; i++) additem(i);
    
    /* 迭 Ҹ Ѵ*/
    setat(0, 1000); /* ϸ INT_MAXȯ */
    
    /*  迭 Ҹ Ѵ*/
    for (i = 0; i < ALLOC_UNIT * 5; i++)
        printf("%d ", getat(i)); /* ϸ INT_MAXȯ */
    printf("\n");
    
    delete(); /*  迭 Ѵ*/
    return 0;
}
