/* ǻ ڸ 16 ǥϴ α׷(HexCharGood.c) */
#include <stdio.h>
#include <string.h>
#include <limits.h>
#define MAX_SIZE 8 /* 16 ڿ ִ*/

char strwork1[MAX_SIZE + 1] = "";
char strwork2[MAX_SIZE + 3] = "";

/* unsigned long κ 16 ڿ ϴ Լ*/
char *genhexchars(unsigned long num, int bytes)
{
    int i = 0, j, length, halfbytecount = 0;
    unsigned char ch;
    /* 16  迭*/
    static unsigned char hexchars[] = { '0', '1', '2', '3',
    '4', '5', '6', '7', '8', '9', 'A', 'B', 'C',
    'D', 'E', 'F' };
    /* strwork2 պκп ڿ  Ѵ*/
    strcpy(strwork2, "0x");
    /* ڸ 16 ڿ ȯѴ*/
    while (i < MAX_SIZE) {
        /* 16  Ѵ*/
        ch = (unsigned char) num % 16;
        /*  Ʈ 16 ǥѴ*/
        strwork1[i++] = hexchars[ch & 0x0f];
        /* 4Ʈ  Ʈ Ѵ*/
        num >>= 4;
        /* ڷ  Ʈ ó  Ѵ*/
        if (++halfbytecount / 2 == bytes)
            break;
    }
    /*   ڸ Ѵ*/
    strwork1[i] = '\0';
    /* ڿ ̸ Ѵ*/
    length = strlen(strwork1);
    /* ڿ  ġѴ*/
    for (i = 0, j = length - 1; i < j; i++, j--) {
        ch = strwork1[i];
        strwork1[i] = strwork1[j];
        strwork1[j] = ch;
    }
    /*  strwork2 Ѵ*/
    strcat(strwork2, strwork1);
    return strwork2;
}

int main(void)
{
    printf("CHAR_MAX  %d 16  ǥ%s\n",
            CHAR_MAX, genhexchars(CHAR_MAX, 1));
    printf("CHAR_MIN  %d 16  ǥ%s\n",
            CHAR_MIN, genhexchars(CHAR_MIN, 1));
    printf("SHRT_MAX  %d 16  ǥ%s\n",
            SHRT_MAX, genhexchars(SHRT_MAX, 2));
    printf("SHRT_MIN  %d 16  ǥ%s\n",
            SHRT_MIN, genhexchars(SHRT_MIN, 2));
    printf("INT_MAX  %d 16  ǥ%s\n",
            INT_MAX, genhexchars(INT_MAX, 4));
    printf("INT_MIN  %d 16  ǥ%s\n",
            INT_MIN, genhexchars(INT_MIN, 4));
    printf("LONG_MAX  %d 16  ǥ%s\n",
            LONG_MAX, genhexchars(LONG_MAX, 4));
    printf("LONG_MIN  %d 16  ǥ%s\n",
            LONG_MIN, genhexchars(LONG_MIN, 4));
    printf("-1  %d 16  ǥ%s\n",
            -1, genhexchars(-1, 4));
    printf("UCHAR_MAX  %u 16  ǥ%s\n",
            UCHAR_MAX, genhexchars(UCHAR_MAX, 1));
    printf("USHRT_MAX  %u 16  ǥ%s\n",
            USHRT_MAX, genhexchars(USHRT_MAX, 2));
    printf("UINT_MAX  %u 16  ǥ%s\n",
            UINT_MAX, genhexchars(UINT_MAX, 4));
    printf("ULONG_MAX  %u 16  ǥ%s\n",
            ULONG_MAX, genhexchars(ULONG_MAX, 4));
    return 0;
}
