/*  ڷ ͸    ٲ ִ α׷(SwapGood.c) */
#include <stdio.h>

/* ̸   ڷ ϱ  */
enum en { char_type, short_type, int_type, long_
float_type, double_type };

/*  ⺻ ڷ ͸ ޴ swap() Լ*/
void swap(void *pd1, void *pd2, int type)
{
    /*  ü */
    char chtemp;
    short stemp;
    int ntemp;
    long ltemp;
    float ftemp;
    double dtemp;
    
    switch (type) {
        case 0: /* char unsigned char*/
            chtemp = *(char *) pd1;
            *(char *) pd1 = *(char *) pd2;
            *(char *) pd2 = chtemp;
            break;
        case 1: /* short unsigned short*/
            stemp = *(short *) pd1;
            *(short *) pd1 = *(short *) pd2;
            *(short *) pd2 = stemp;
            break;
        case 2: /* int unsigned int*/
            ntemp = *(int *) pd1;
            *(int *) pd1 = *(int *) pd2;
            *(int *) pd2 = ntemp;
            break;
        case 3: /* long unsigned long*/
            ltemp = *(long *) pd1;
            *(long *) pd1 = *(long *) pd2;
            *(long *) pd2 = ltemp;
            break;
        case 4: /* float*/
            ftemp = *(float *) pd1;
            *(float *) pd1 = *(float *) pd2;
            *(float *) pd2 = ftemp;
            break;
        case 5: /* double*/
            dtemp = *(double *) pd1;
            *(double *) pd1 = *(double *) pd2;
            *(double *) pd2 = dtemp;
            break;
    }
}
int main(void)
{
    char ch1 = 'A', ch2 = 'Z';
    unsigned char uch1 = 255, uch2 = 0;
    short s1 = 3000, s2 = 8000;
    unsigned short us1 = 10000u, us2 = 50000u;
    int n1 = 500, n2 = 1000;
    unsigned int u1 = 60000u, u2 = 40000u;
    float f1 = 0.555f, f2 = 3.2323f;
    double d1 = 2.224586, d2 = 0.333345;
    
    /* char 2  ٲ ִ´*/
    swap(&ch1, &ch2, char_type);
    printf("%c %c\n", ch1, ch2);
    /* unsigned char 2  ٲ ִ´*/
    swap(&uch1, &uch2, char_type);
    printf("%d %d\n", uch1, uch2);
    /* short 2  ٲ ִ´*/
    swap(&s1, &s2, short_type);
    printf("%d %d\n", s1, s2);
    /* unsigned short 2  ٲ ִ´*/
    swap(&us1, &us2, short_type);
    printf("%u %u\n", us1, us2);
    /* int 2  ٲ ִ´*/
    swap(&n1, &n2, int_type);
    printf("%d %d\n", n1, n2);
    /* unsigned int 2  ٲ ִ´*/
    swap(&u1, &u2, int_type);
    printf("%u %u\n", u1, u2);
    /* float 2  ٲ ִ´*/
    swap(&f1, &f2, float_type);
    printf("%f %f\n", f1, f2);
    /* double 2  ٲ ִ´*/
    swap(&d1, &d2, double_type);
    printf("%f %f\n", d1, d2);
    return 0;
}
